#include <iostream>
#include <pthread.h>
using namespace std;

int counter = 0;
pthread_mutex_t counterMutex;

void* counterThread(void* args)
{
    for(int i = 0; i < 10000000; i++) {
        pthread_mutex_lock(&counterMutex);
        counter++;
        pthread_mutex_unlock(&counterMutex);
    }
    return 0;
}

int main() {
    pthread_t threads[4];
    pthread_mutex_init(&counterMutex, NULL);
    int returnValues[4];
    for(int i = 0; i < 4; i++)
        pthread_create(&threads[i], NULL, counterThread, NULL);

    for(int i = 0; i < 4; i++)
        pthread_join(threads[i], (void**)&returnValues[i]);
    cout << counter << endl;
    pthread_mutex_destroy(&counterMutex);
    return 0;
}